/*	 Some 3D math routines
 *
 * Copyright 2001 TransGaming Technologies Inc.
 */

#include "config.h"

#include <assert.h>
#include <stdlib.h>

#include "debugtools.h"
#include "d3d.h"
#include "d3ddevice/maths.h"

DEFAULT_DEBUG_CHANNEL(ddraw);

#define CALC_ITEM(r,c) \
  m->_##r##c = \
  m1->_##r##1 * m2->_1##c + \
  m1->_##r##2 * m2->_2##c + \
  m1->_##r##3 * m2->_3##c + \
  m1->_##r##4 * m2->_4##c

void MatrixMultiply(LPD3DMATRIX m, LPD3DMATRIX m1, LPD3DMATRIX m2)
{
  CALC_ITEM(1,1); CALC_ITEM(1,2); CALC_ITEM(1,3); CALC_ITEM(1,4);
  CALC_ITEM(2,1); CALC_ITEM(2,2); CALC_ITEM(2,3); CALC_ITEM(2,4);
  CALC_ITEM(3,1); CALC_ITEM(3,2); CALC_ITEM(3,3); CALC_ITEM(3,4);
  CALC_ITEM(4,1); CALC_ITEM(4,2); CALC_ITEM(4,3); CALC_ITEM(4,4);
}

#undef CALC_ITEM

#define CALC_ITEM(c) \
  v->u1.x * m->_1##c + \
  v->u2.y * m->_2##c + \
  v->u3.z * m->_3##c + \
  m->_4##c

D3DVALUE MatrixApply(LPD3DVECTOR r, LPD3DVECTOR v, LPD3DMATRIX m)
{
  r->u1.x = CALC_ITEM(1);
  r->u2.y = CALC_ITEM(2);
  r->u3.z = CALC_ITEM(3);
  return CALC_ITEM(4); /* homogenous W */
}

#undef CALC_ITEM
