#ifndef WINE_D3DHALP_H_INCLUDED
#define WINE_D3DHALP_H_INCLUDED

#include "windef.h"
#include "ddrawi.h"
#include "d3dtypes.h"

struct _D3DHAL_CALLBACKS;
struct _D3DHAL_CALLBACKS2;

typedef struct {
    D3DLIGHT7 l;
    DWORD flags, devnum;
    D3DVALUE devpos[4];
} D3D_Light;

typedef struct
{
    LPDDRAWI_DIRECTDRAW_LCL lcl;
    LPDDRAWI_DDRAWSURFACE_LCL surf, zbuf;
    ULONG_PTR dwhContext;
    LPDDHAL_GETDRIVERINFO gdi;
    struct _D3DHAL_CALLBACKS *cbs1;
    struct _D3DHAL_CALLBACKS2 *cbs2;
    BOOL in_scene;
    DWORD state_block;
    DWORD renderstate[256];
    DWORD texstagestate[8][32];
    D3DMATRIX xfrm[8], txfrm[8];
    D3DVIEWPORT7 viewport;
    D3DMATERIAL7 material;
    DWORD numlights;
    D3D_Light *light;
    D3DVALUE clipplane[32][4];
} D3D_P,*LPD3D_P;

typedef struct
{
    DDRAWI_DDRAWSURFACE_LCL lcl;
    DDRAWI_DDRAWSURFACE_MORE more;
    LPDDRAWI_DDRAWSURFACE_GBL_MORE gmore;
    DDRAWI_DDRAWSURFACE_GBL gbl;
    DDRAWI_DDRAWSURFACE_GBL_MORE gbl_more;
    DWORD tdata[8];
} D3D_T,*LPD3D_T;

#endif
